---
title: Service Worker API
slug: Web/API/Service_Worker_API
tags:
  - API
  - Landing
  - Offline
  - Overview
  - Reference
  - Service Workers
  - Workers
---
<div>{{ServiceWorkerSidebar}}</div>

<p class="summary">Service workers essentially act as proxy servers that sit between web applications, the browser, and the network (when available). They are intended, among other things, to enable the creation of effective offline experiences, intercept network requests and take appropriate action based on whether the network is available, and update assets residing on the server. They will also allow access to push notifications and background sync APIs.</p>

<h2 id="Service_worker_concepts_and_usage">Service worker concepts and usage</h2>

<p>A service worker is an event-driven <a href="/en-US/docs/Web/API/Worker">worker</a> registered against an origin and a path. It takes the form of a JavaScript file that can control the web-page/site that it is associated with, intercepting and modifying navigation and resource requests, and caching resources in a very granular fashion to give you complete control over how your app behaves in certain situations (the most obvious one being when the network is not available).</p>

<p>A service worker is run in a worker context: it therefore has no DOM access, and runs on a different thread to the main JavaScript that powers your app, so it is non-blocking. It is designed to be fully async; as a consequence, APIs such as synchronous <a href="/en-US/docs/Web/API/XMLHttpRequest">XHR</a> and <a href="/en-US/docs/Web/API/Web_Storage_API">Web Storage</a> can't be used inside a service worker.</p>

<p>Service workers only run over HTTPS, for security reasons. Having modified network requests, wide open to <em>man in the middle</em> attacks would be really bad. In Firefox, Service Worker APIs are also hidden and cannot be used when the user is in <a href="https://support.mozilla.org/en-US/kb/private-browsing-use-firefox-without-history">private browsing mode</a>.</p>

<div class="note">
<p><strong>Note</strong>: Unlike previous attempts in this area such as <a href="http://alistapart.com/article/application-cache-is-a-douchebag">AppCache</a>, service workers don't make assumptions about what you are trying to do, but then break when those assumptions are not exactly right. Instead, service workers give you much more granular control.</p>
</div>

<div class="note">
<p><strong>Note</strong>: Service workers make heavy use of <a href="/en-US/docs/Web/JavaScript/Reference/Global_Objects/Promise">promises</a>, as generally they will wait for responses to come through, after which they will respond with a success or failure action. The promises architecture is ideal for this.</p>
</div>

<h3 id="Registration">Registration</h3>

<p>A service worker is first registered using the {{DOMxRef("ServiceWorkerContainer.register()")}} method. If successful, your service worker will be downloaded to the client and attempt installation/activation (see below) for URLs accessed by the user inside the whole origin, or inside a subset specified by you.</p>

<h3 id="Download_install_and_activate">Download, install and activate</h3>

<p>At this point, your service worker will observe the following lifecycle:</p>

<ol>
 <li>Download</li>
 <li>Install</li>
 <li>Activate</li>
</ol>

<p>The service worker is immediately downloaded when a user first accesses a service worker–controlled site/page.</p>

<p>After that, it is updated when:</p>

<ul>
 <li>A navigation to an in-scope page occurs.</li>
 <li>An event is fired on the service worker and it hasn't been downloaded in the last 24 hours.</li>
</ul>

<p>Installation is attempted when the downloaded file is found to be new — either different to an existing service worker (byte-wise compared), or the first service worker encountered for this page/site.</p>

<p>If this is the first time a service worker has been made available, installation is attempted, then after a successful installation, it is activated.</p>

<p>If there is an existing service worker available, the new version is installed in the background, but not yet activated — at this point it is called the <em>worker in waiting</em>. It is only activated when there are no longer any pages loaded that are still using the old service worker. As soon as there are no more pages to be loaded, the new service worker activates (becoming the <em>active worker</em>). Activation can happen sooner using {{DOMxRef("ServiceWorkerGlobalScope.skipWaiting()")}} and existing pages can be claimed by the active worker using {{DOMxRef("Clients.claim()")}}.</p>

<p>You can listen for the {{domxref("ServiceWorkerGlobalScope/install_event", "install")}} event; a standard action is to prepare your service worker for usage when this fires, for example by creating a cache using the built in storage API, and placing assets inside it that you'll want for running your app offline.</p>

<p>There is also an {{domxref("ServiceWorkerGlobalScope/activate_event", "activate")}} event. The point where this event fires is generally a good time to clean up old caches and other things associated with the previous version of your service worker.</p>

<p>Your service worker can respond to requests using the {{DOMxRef("FetchEvent")}} event. You can modify the response to these requests in any way you want, using the {{DOMxRef("FetchEvent.respondWith()")}} method.</p>

<div class="note">
<p><strong>Note</strong>: Because <code>install</code>/<code>activate</code> events could take a while to complete, the service worker spec provides a {{domxref("ExtendableEvent.waitUntil", "waitUntil()")}} method. Once it is called on <code>install</code> or <code>activate</code> events with a promise, functional events such as <code>fetch</code> and <code>push</code> will wait until the promise is successfully resolved.</p>
</div>

<p>For a complete tutorial to show how to build up your first basic example, read <a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a>.</p>

<h2 id="Other_use_case_ideas">Other use case ideas</h2>

<p>Service workers are also intended to be used for such things as:</p>

<ul>
 <li>Background data synchronization.</li>
 <li>Responding to resource requests from other origins.</li>
 <li>Receiving centralized updates to expensive-to-calculate data such as geolocation or gyroscope, so multiple pages can make use of one set of data.</li>
 <li>Client-side compiling and dependency management of CoffeeScript, less, CJS/AMD modules, etc. for development purposes.</li>
 <li>Hooks for background services.</li>
 <li>Custom templating based on certain URL patterns.</li>
 <li>Performance enhancements, for example pre-fetching resources that the user is likely to need in the near future, such as the next few pictures in a photo album.</li>
</ul>

<p>In the future, service workers will be able to do a number of other useful things for the web platform that will bring it closer towards native app viability. Interestingly, other specifications can and will start to make use of the service worker context, for example:</p>

<ul>
 <li><a href="https://github.com/slightlyoff/BackgroundSync">Background synchronization</a>: Start up a service worker even when no users are at the site, so caches can be updated, etc.</li>
 <li><a href="/en-US/docs/Web/API/Push_API">Reacting to push messages</a>: Start up a service worker to send users a message to tell them new content is available.</li>
 <li>Reacting to a particular time &amp; date.</li>
 <li>Entering a geo-fence.</li>
</ul>

<h2 id="Interfaces">Interfaces</h2>

<dl>
 <dt>{{DOMxRef("Cache")}} {{Experimental_Inline}}</dt>
 <dd>Represents the storage for {{DOMxRef("Request")}} / {{DOMxRef("Response")}} object pairs that are cached as part of the {{DOMxRef("ServiceWorker")}} life cycle.</dd>
 <dt>{{DOMxRef("CacheStorage")}} {{Experimental_Inline}}</dt>
 <dd>Represents the storage for {{DOMxRef("Cache")}} objects. It provides a master directory of all the named caches that a {{DOMxRef("ServiceWorker")}} can access, and maintains a mapping of string names to corresponding {{DOMxRef("Cache")}} objects.</dd>
 <dt>{{DOMxRef("Client")}} {{Experimental_Inline}}</dt>
 <dd>Represents the scope of a service worker client. A service worker client is either a document in a browser context or a {{DOMxRef("SharedWorker")}}, which is controlled by an active worker.</dd>
 <dt>{{DOMxRef("Clients")}} {{Experimental_Inline}}</dt>
 <dd>Represents a container for a list of {{DOMxRef("Client")}} objects; the main way to access the active service worker clients at the current origin.</dd>
 <dt>{{DOMxRef("ExtendableEvent")}} {{Experimental_Inline}}</dt>
 <dd>Extends the lifetime of the <code>install</code> and <code>activate</code> events dispatched on the {{DOMxRef("ServiceWorkerGlobalScope")}}, as part of the service worker lifecycle. This ensures that any functional events (like {{DOMxRef("FetchEvent")}}) are not dispatched to the {{DOMxRef("ServiceWorker")}}, until it upgrades database schemas, and deletes outdated cache entries, etc.</dd>
 <dt>{{DOMxRef("ExtendableMessageEvent")}} {{Experimental_Inline}}</dt>
 <dd>The event object of a {{domxref("ServiceWorkerGlobalScope/message_event")}} event fired on a service worker (when a channel message is received on the {{DOMxRef("ServiceWorkerGlobalScope")}} from another context) — extends the lifetime of such events.</dd>
 <dt>{{DOMxRef("FetchEvent")}} {{Experimental_Inline}}</dt>
 <dd>The parameter passed into the {{DOMxRef("ServiceWorkerGlobalScope.onfetch")}} handler, <code>FetchEvent</code> represents a fetch action that is dispatched on the {{DOMxRef("ServiceWorkerGlobalScope")}} of a {{DOMxRef("ServiceWorker")}}. It contains information about the request and resulting response, and provides the {{DOMxRef("FetchEvent.respondWith", "FetchEvent.respondWith()")}} method, which allows us to provide an arbitrary response back to the controlled page.</dd>
 <dt>{{DOMxRef("InstallEvent")}} {{Experimental_Inline}}</dt>
 <dd>The parameter passed into the {{DOMxRef("ServiceWorkerGlobalScope.oninstall", "oninstall")}} handler, the <code>InstallEvent</code> interface represents an install action that is dispatched on the {{DOMxRef("ServiceWorkerGlobalScope")}} of a {{DOMxRef("ServiceWorker")}}. As a child of {{DOMxRef("ExtendableEvent")}}, it ensures that functional events such as {{DOMxRef("FetchEvent")}} are not dispatched during installation.</dd>
 <dt>{{DOMxRef("NavigationPreloadManager")}} {{Experimental_Inline}}</dt>
 <dd>Provides methods for managing the preloading of resources with a service worker.</dd>
 <dt>{{DOMxRef("Navigator.serviceWorker")}}</dt>
 <dd>Returns a {{DOMxRef("ServiceWorkerContainer")}} object, which provides access to registration, removal, upgrade, and communication with the {{DOMxRef("ServiceWorker")}} objects for the <a href="https://html.spec.whatwg.org/multipage/browsers.html#concept-document-window">associated document</a>.</dd>
 <dt>{{DOMxRef("NotificationEvent")}} {{Experimental_Inline}}</dt>
 <dd>The parameter passed into the {{DOMxRef("ServiceWorkerGlobalScope.onnotificationclick", "onnotificationclick")}} handler, the <code>NotificationEvent</code> interface represents a notification click event that is dispatched on the {{DOMxRef("ServiceWorkerGlobalScope")}} of a {{DOMxRef("ServiceWorker")}}.</dd>
 <dt>{{DOMxRef("ServiceWorker")}} {{Experimental_Inline}}</dt>
 <dd>Represents a service worker. Multiple browsing contexts (e.g. pages, workers, etc.) can be associated with the same <code>ServiceWorker</code> object.</dd>
 <dt>{{DOMxRef("ServiceWorkerContainer")}} {{Experimental_Inline}}</dt>
 <dd>Provides an object representing the service worker as an overall unit in the network ecosystem, including facilities to register, unregister, and update service workers, and access the state of service workers and their registrations.</dd>
 <dt>{{DOMxRef("ServiceWorkerGlobalScope")}}</dt>
 <dd>Represents the global execution context of a service worker.</dd>
 <dt>{{DOMxRef("ServiceWorkerMessageEvent")}} {{Deprecated_Inline}}</dt>
 <dd>Represents a message sent to a {{DOMxRef("ServiceWorkerGlobalScope")}}. <strong>Note that this interface is deprecated in modern browsers. Service worker messages will now use the {{DOMxRef("MessageEvent")}} interface, for consistency with other web messaging features.</strong></dd>
 <dt>{{DOMxRef("ServiceWorkerRegistration")}} {{Experimental_Inline}}</dt>
 <dd>Represents a service worker registration.</dd>
 <dt>{{DOMxRef("ServiceWorkerState")}} {{Experimental_Inline}}</dt>
 <dd>Associated with its {{domxref("ServiceWorker")}}'s state.</dd>
 <dt>{{DOMxRef("SyncEvent")}} {{Non-standard_Inline}}</dt>
 <dd>
 <p>The SyncEvent interface represents a sync action that is dispatched on the {{DOMxRef("ServiceWorkerGlobalScope")}} of a ServiceWorker.</p>
 </dd>
 <dt>{{DOMxRef("SyncManager")}} {{Non-standard_Inline}}</dt>
 <dd>Provides an interface for registering and listing sync registrations.</dd>
 <dt>{{DOMxRef("WindowClient")}} {{Experimental_Inline}}</dt>
 <dd>Represents the scope of a service worker client that is a document in a browser context, controlled by an active worker. This is a special type of {{DOMxRef("Client")}} object, with some additional methods and properties available.</dd>
</dl>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("Service Workers")}}</td>
   <td>{{Spec2("Service Workers")}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="https://serviceworke.rs">ServiceWorker Cookbook</a></li>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a href="https://github.com/mdn/sw-test">Service workers basic code example</a></li>
 <li><a href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li>{{jsxref("Promise")}}</li>
</ul>
